"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var WebSocket = require("ws");
var webSocket_1 = require("rxjs/webSocket");
var binance_axios_config_1 = require("./binance_axios_config");
var binancePublicWS = webSocket_1.webSocket({
    url: binance_axios_config_1.baseWsURL + "/stream",
    WebSocketCtor: WebSocket,
});
exports.binancePublicWS = binancePublicWS;
var getBinancePublicObservableFromWS = function (streamNames, filterFn, unsubscriptionData) {
    if (filterFn === void 0) { filterFn = function (_a) {
        var _b = _a.stream, stream = _b === void 0 ? '' : _b;
        return streamNames.includes(stream);
    }; }
    var subscriptionData = {
        method: "SUBSCRIBE",
        params: streamNames,
        id: new Date().getTime()
    };
    var publicObservable$ = binancePublicWS.multiplex(function () { return subscriptionData; }, function () { return unsubscriptionData; }, filterFn);
    return publicObservable$;
};
exports.getBinancePublicObservableFromWS = getBinancePublicObservableFromWS;
